## tinyssh 20190101

=== Makefile ===
compile: make-tinyssh.sh
	sh -e make-tinyssh.sh
clean:
	rm -rf build
install:
	sh -e make-install.sh $(DESTDIR)
deb:
	dpkg-buildpackage -b -rfakeroot -us -uc

## tinyssh 20180101

=== debian/changelog ===
tinyssh (20180101-1) unstable; urgency=medium

  [ Jan Mojžíš ]
  * d/systemd/tinysshd.socket - changed ConditionPathExists
    /etc/tinyssh/disable_tinysshd_tcp -> /etc/tinyssh/disable_tinysshd
  * d/systemd/tinysshd@.service - removed Restart=on-failure
  * d/rules - print debug log when compilation fails
  * d/rules - switched from dh_systemd_enable to dh_installsystemd
  * d/upstream/signing-key.asc - added
  * d/watch - added gpg signature checking
  * d/compat - switched to debhelper 11
  * d/control - bump to standards version 4.1.3
  * d/control - removed useless 'Conflicts: tinyssh-run'
  * d/tinysshd.lintian-overrides - added no-upstream-changelog
  * New upstream version 20180101:
      - crypto library speedup
      - setting close-on-exec for /dev/urandom filedescriptor
      - cleanup in code
  * Moved to unstable

  [ Ondřej Nový ]
  * Move source of test into separate file: debian/tests/checksshstring.c

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Wed, 03 Jan 2018 07:42:15 +0100

tinyssh (20160812-1) experimental; urgency=medium

  * Initial release. (Closes: #832611)

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Fri, 12 Aug 2016 06:03:38 +0200

=== debian/control ===
Source: tinyssh
Section: net
Priority: optional
Build-Depends: debhelper (>= 11)
Maintainer: Jan Mojžíš <jan.mojzis@gmail.com>
Homepage: https://mojzis.com/software/tinyssh/
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/tinyssh.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/tinyssh.git

Package: tinysshd
Depends: systemd-sysv,
         ${misc:Depends},
         ${shlibs:Depends}
Provides: ssh-server
Architecture: any
Description: Tiny SSH server - daemon
 TinySSH is a minimalistic SSH server which implements only a subset of
 SSHv2 features.
 TinySSH supports only secure cryptography (minimum 128-bit security, protected
 against cache-timing attacks) ED25519, Curve25519(X25519), CHACHA20POLY1305,
 also older standard NISTP256 ECDSA, NISTP256 ECDH, AES256 + HMAC-SHA256.
 TinySSH implements only safe public-key authentication,
 password or hostbased authentication is not implemented.
 TinySSH has less than 100000 words of code, so it's very easily auditable.

=== debian/tests/control ===
Tests: tinysshdtest
Depends: tinysshd, gcc
Restrictions: allow-stderr

## tinyssh 20180201

=== debian/changelog ===
tinyssh (20180201-1) unstable; urgency=medium

  * d/tests/01makekeyprintkey - added test for
    tinysshd-makekey and tinysshd-printkey tools
  * d/tests/02handshake - added simple python3 tests
    which connects to local tinysshd server and
    checks if TinySSH supports chacha20poly1305 and also checks
    if TinySSH rejects bad (zero) public-key
  * autopkgtests - removed autopkgtest written in C
  * autopkgtests - switched env. variable ADTTMP to AUTOPKGTEST_TMP
  * d/control - dependency on systemd instead of systemd-sysv
  * New upstream version 20180201:
      - removed little-endian detection/optimization and added full
        processor independent implementation of poly1305,chacha20
      - cleanups
      - added KEX curve25519-sha256
      - minor fixes

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Thu, 01 Feb 2018 06:59:37 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/tinyssh.git
 
 Package: tinysshd
-Depends: systemd-sysv,
+Depends: systemd,
          ${misc:Depends},
          ${shlibs:Depends}
 Provides: ssh-server

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all


override_dh_installsystemd:
	dh_installsystemd -ptinysshd tinysshd@.service
	dh_installsystemd -ptinysshd tinysshd.socket

override_dh_auto_install:
	echo >/dev/null

override_dh_auto_build:
	dh_auto_build || cat build/log

%:
	dh $@

=== debian/tests/control ===
Tests: 01makekeyprintkey, 02handshake
Depends: tinysshd, python3
Restrictions: allow-stderr

## tinyssh 20190101

=== debian/changelog ===
tinyssh (20190101-1ubuntu1) jammy; urgency=medium

  * d/p/openssh-8.9-workaround.patch: upstream cherry-pick to fix the package
    against OpenSSL 8.9 (LP: #1964585)

 -- Simon Chopin <simon.chopin@canonical.com>  Fri, 11 Mar 2022 12:15:11 +0100

tinyssh (20190101-1build1) eoan; urgency=medium

  * No-change upload with strops.h and sys/strops.h removed in glibc.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Sep 2019 11:14:30 +0000

tinyssh (20190101-1) unstable; urgency=medium

  * d/tests - added 03exitcodes test, it creates ssh connection, exits
    with status 0-255 and checks if tinyssh server sends the status code
    to the client
  * d/tests - added 04sftp test, it tests sftp subsystem
  * d/tests - added 05authorizedkeys, it tests if tinyssh rejects login
    using malformed authorized_keys
  * d/upstream - updated minimal signing-key.asc, removed extra signatures
  * d/tests - fixed 02handshake tests. Runs and tests tinyssh on port 222,
    because default port 22 in autopkgtest environment is used by OpenSSH.
  * d/tests - added 06transfer, tries to send random data to tinyssh server,
    than tries to receive data from tinyssh server and compares checksums.
  * New upstream version 20190101:
    - tinysshd binary optimized for smaller size
    - created multi-call tinysshd binary
    - removed aes256,nistp256,hmacsha256
    - added postquantum KEX sntrup4591761x25519-sha512@tinyssh.org
  * d/.links - tinysshd-{printkey,makekey} is symbolic link to tinysshd binary
  * d/control - bump to standards version 4.3.0 (no modifications)
  * d/tinysshd.default - removed aes256,nistp256,hmacsha256 options
  * d/control - removed info about aes256,nistp256,hmacsha256
  * d/compat - bump debhelper compat level to 12 and use debhelper-compat

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Wed, 02 Jan 2019 06:01:58 +0100

tinyssh (20180201-2) unstable; urgency=medium

  * d/copyright - fixed url http->https
  * d/control - bump to standards version 4.2.1
  * d/control - Vcs-* moved to salsa.debian.org
  * Convert git repository from git-dpm to gbp layout
  * d/upstream/metadata - added
  * d/TODO - removed
  * d/control - removed dependency on systemd (Closes: #911539)
  * d/tinysshd.lintian-overrides removed
  * d/tests/control - added restrictions isolation-container and
    added dependency on systemd-sysv, systemd

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Tue, 23 Oct 2018 14:49:24 +0200

=== debian/control ===
Source: tinyssh
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 12)
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Jan Mojžíš <jan.mojzis@gmail.com>
Homepage: https://mojzis.com/software/tinyssh/
Standards-Version: 4.3.0
Vcs-Git: https://salsa.debian.org/debian/tinyssh.git
Vcs-Browser: https://salsa.debian.org/debian/tinyssh

Package: tinysshd
Depends: ${misc:Depends},
         ${shlibs:Depends}
Provides: ssh-server
Architecture: any
Description: Tiny SSH server - daemon
 TinySSH is a minimalistic SSH server which implements only a subset of
 SSHv2 features.
 TinySSH supports only secure cryptography (minimum 128-bit security, protected
 against cache-timing attacks) ED25519, Curve25519(X25519), CHACHA20POLY1305.
 TinySSH implements only safe public-key authentication,
 password or hostbased authentication is not implemented.
 TinySSH has less than 100000 words of code, so it's very easily auditable.

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,6 @@
 #export DH_VERBOSE=1
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-
 
 override_dh_installsystemd:
 	dh_installsystemd -ptinysshd tinysshd@.service

=== debian/tests/control ===
Tests: 01makekeyprintkey
Depends: tinysshd
Restrictions: allow-stderr

Tests: 02handshake
Depends: systemd-sysv, systemd, tinysshd, python3, ucspi-tcp
Restrictions: allow-stderr, needs-root, isolation-container

Tests: 03exitcodes
Depends: tinysshd, openssh-client, ucspi-tcp
Restrictions: allow-stderr, needs-root

Tests: 04sftp
Depends: tinysshd, openssh-client, openssh-sftp-server, ucspi-tcp
Restrictions: allow-stderr, needs-root

Tests: 05authorizedkeys
Depends: tinysshd, openssh-client, ucspi-tcp
Restrictions: allow-stderr, needs-root

Tests: 06transfer
Depends: tinysshd, openssh-client, ucspi-tcp
Restrictions: allow-stderr, needs-root

## tinyssh 20220311

=== debian/changelog ===
tinyssh (20220311-2) unstable; urgency=medium

  [ Colin Watson ]
  * d/rules: ensure non-zero exit status when dh_auto_build fails

  [ Jan Mojžíš ]
  * debian/systemd/tinysshd: update systemd service to accept status code 111

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Wed, 16 Mar 2022 17:19:43 +0100

tinyssh (20220311-1) unstable; urgency=medium

  * New upstream version 20220311
    - fixed build on big-endian platforms

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Sat, 12 Mar 2022 12:55:53 +0000

tinyssh (20220305-1) unstable; urgency=medium

  * d/watch - fixed github perl regexp
  * d/control - bump debhelper compat level to 13
  * d/control - bump to standards version 4.6.0 (no modifications)
  * d/control - added Rules-Requires-Root: no
  * d/tests - added 07kex test, tests supported KEX including
    new sntrup761x25519-sha512@openssh.com
  * d/tests - removed unnecessary restrictions allow-stderr, needs-root
  * d/tests - added 08badauth test, it tests if tinysshd rejects login
    when authorized_keys are stored in directory with group/other writable
    permitions
  * d/rules - fixed cross-compile build
  * d/tinysshd.manpages man/tinysshd-{make,print}key.1 renamed to
    man/tinysshd-{make,print}key.8
  * d/rules - disable some case tests to allow reproducible build
  * New upstream version 20220305
    - removed sntrup4591761x25519-sha512@tinyssh.org
    - added sntrup761x25519-sha512@openssh.com
    - fixed error message when second channel is requested (Closes: 995146)
    - man/tinysshd-{make,print}key.1 -> man/tinysshd-{make,print}key.8
    - added tinysshnoneauthd binary
    - workaround for incoming packets that doesn't honor
      the max. packet length (Closes: 1006801)
  * d/watch - fixed regexp

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Thu, 10 Mar 2022 17:43:02 +0000

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,16 @@
 Source: tinyssh
 Section: net
 Priority: optional
-Build-Depends: debhelper-compat (= 12)
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Jan Mojžíš <jan.mojzis@gmail.com>
+Build-Depends: debhelper-compat (= 13)
+Maintainer: Jan Mojžíš <jan.mojzis@gmail.com>
 Homepage: https://mojzis.com/software/tinyssh/
-Standards-Version: 4.3.0
+Standards-Version: 4.6.0
 Vcs-Git: https://salsa.debian.org/debian/tinyssh.git
 Vcs-Browser: https://salsa.debian.org/debian/tinyssh
+Rules-Requires-Root: no
 
 Package: tinysshd
-Depends: ${misc:Depends},
-         ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Provides: ssh-server
 Architecture: any
 Description: Tiny SSH server - daemon

## tinyssh 20220801

=== debian/changelog ===
tinyssh (20220801-1) unstable; urgency=medium

  * New upstream version 20220801
  * d/gbp.conf added new gbp.conf configuration file
  * d/control: bump Standards-Version to 4.6.1, no changes

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Mon, 01 Aug 2022 08:28:20 +0200

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/(\d\S+)\.tar\.gz/tinyssh-$1\.tar\.gz/,\
pgpsigurlmangle=s/archive\/.+\/(\d\S+)\.tar\.gz/releases\/download\/$1\/$1\.tar\.gz\.asc/ \
  https://github.com/janmojzis/tinyssh/releases/latest .*/(\d\S+)\.tar\.gz

## tinyssh 20230101

=== debian/changelog ===
tinyssh (20230101-1) unstable; urgency=medium

  * New upstream version 20230101
  * d/copyright: updated, generated using 'cme update dpkg-copyright'
  * d/copyright: update to CC0
  * d/gbp.conf: debian-branch = main

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Sun, 01 Jan 2023 09:33:58 +0100

tinyssh (20220801-2) unstable; urgency=medium

  * d/watch fixed url

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Tue, 25 Oct 2022 17:08:45 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Build-Depends: debhelper-compat (= 13)
 Maintainer: Jan Mojžíš <jan.mojzis@gmail.com>
 Homepage: https://mojzis.com/software/tinyssh/
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Git: https://salsa.debian.org/debian/tinyssh.git
 Vcs-Browser: https://salsa.debian.org/debian/tinyssh
 Rules-Requires-Root: no

=== debian/tests/control ===
Tests: 01makekeyprintkey
Depends: tinysshd

Tests: 02handshake
Depends: python3, systemd, systemd-sysv, tinysshd, ucspi-tcp
Restrictions: allow-stderr, needs-root, isolation-container

Tests: 03exitcodes
Depends: openssh-client, tinysshd, ucspi-tcp

Tests: 04sftp
Depends: openssh-client, openssh-sftp-server, tinysshd, ucspi-tcp

Tests: 05authorizedkeys
Depends: openssh-client, tinysshd, ucspi-tcp

Tests: 06transfer
Depends: openssh-client, tinysshd, ucspi-tcp

Tests: 07kex
Depends: openssh-client, tinysshd, ucspi-tcp

Tests: 08badauth
Depends: openssh-client, tinysshd, ucspi-tcp

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/(\d\S+)\.tar\.gz/tinyssh-$1\.tar\.gz/,\
pgpsigurlmangle=s/archive\/.+\/(\d\S+)\.tar\.gz/releases\/download\/$1\/$1\.tar\.gz\.asc/ \
  https://github.com/janmojzis/tinyssh/tags .*/(\d\S+)\.tar\.gz

## tinyssh 20240101

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,7 @@
 compile: make-tinyssh.sh
 	sh -e make-tinyssh.sh
+cross-compile: make-tinysshcc.sh
+	sh -e make-tinysshcc.sh
 clean:
 	rm -rf build
 install:

=== debian/changelog ===
tinyssh (20240101-2) unstable; urgency=medium

  [ Chris Hofstaedtler ]
  * Install systemd units into /usr, update hard-coded paths. (Closes: #1060081)

  [ Jan Mojžíš ]
  * d/copyright: use link to the CC0 file
  * d/copyright: bump my copyright year

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Mon, 08 Jan 2024 09:56:58 +0100

tinyssh (20240101-1) unstable; urgency=medium

  * New upstream version 20240101
  * d/p/0001-channel_forkpty.c-fix-race-condition-79.patch removed
  * d/p/0003-channel.c-ignore-SSH_MSG_CHANNEL_EOF-in-terminal-mod.patch removed
  * d/p/0004-implementation-kex-strict-s-v00-openssh.com-82.patch removed
  * d/watch: remove filenamemangle and use characters @ANY_VERSION@@ARCHIVE_EXT@
  * d/gbp.conf: add upstream-signatures = on, track-missing = True

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Mon, 01 Jan 2024 10:58:09 +0100

tinyssh (20230101-4) unstable; urgency=medium

  * d/p/0004-implementation-kex-strict-s-v00-openssh.com-82.patch:
    backported key exchange protocol extension kex-strict-s-v00@openssh.com
    from the upstream. Mitigates CVE-2023-48795 "Terrapin attack".
    (Closes: 1059058)
  * d/t/10rekey added, tests SSH connection rekeying

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Wed, 20 Dec 2023 23:10:12 +0100

tinyssh (20230101-3) unstable; urgency=medium

  * Fix terminal connection if stdin is redirected to /dev/null (ssh -tt -n):
    * d/p/0001-channel_forkpty.c-fix-race-condition-79.patch add
    * d/p/0003-channel.c-ignore-SSH_MSG_CHANNEL_EOF-in-terminal-mod.patch add
    * d/t/09termexec add

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Sun, 17 Dec 2023 23:02:51 +0100

tinyssh (20230101-2) unstable; urgency=medium

  * d/t/05authorizedkeys fixed permissions when creating authorized_keys,
    tnx Lukas Mardian (Closes: 1034513)
  * d/t/{04sftp,05authorizedkeys,06transfer,07kex,08badauth} fixed tests,
    added short sleep to give tcpserver time to start, tnx Lukas Mardian
    (Closes: 1034512)
  * d/control: bump Standards-Version to 4.6.2, no changes

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Sun, 11 Jun 2023 09:12:38 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Build-Depends: debhelper-compat (= 13)
 Maintainer: Jan Mojžíš <jan.mojzis@gmail.com>
 Homepage: https://mojzis.com/software/tinyssh/
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/debian/tinyssh.git
 Vcs-Browser: https://salsa.debian.org/debian/tinyssh
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# crossbuild
ifneq  ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
include /usr/share/dpkg/buildtools.mk
endif

override_dh_installsystemd:
	dh_installsystemd -ptinysshd tinysshd@.service
	dh_installsystemd -ptinysshd tinysshd.socket

override_dh_auto_install:
	echo >/dev/null

override_dh_auto_configure:
	# disable some case tests, to allow reproducible build
	( cd tinyssh-tests; [ -f opentest.c.orig ] || ( mv opentest.c opentest.c.orig; ln -s emptytest.c opentest.c; ) )
	( cd tinyssh-tests; [ -f dropuidgidtest.c.orig ] || ( mv dropuidgidtest.c dropuidgidtest.c.orig; ln -s emptytest.c dropuidgidtest.c; ) )
	( cd tinyssh-tests; [ -f subprocess_authtest.c.orig ] || ( mv subprocess_authtest.c subprocess_authtest.c.orig; ln -s emptytest.c subprocess_authtest.c; ) )
	# backup files
	[ -f 'conf-cc.orig' ] || cp 'conf-cc' 'conf-cc.orig'
	[ -f 'conf-ar.orig' ] || cp 'conf-ar' 'conf-ar.orig'
	echo '$(CC)' > conf-cc
	echo '$(AR)' > conf-ar

override_dh_auto_build:
ifneq  ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	make cross-compile || { cat build/log; exit 1; }
else
	dh_auto_build || { cat build/log; exit 1; }
endif

override_dh_auto_clean:
	dh_auto_clean
	mv -f 'tinyssh-tests/opentest.c.orig' 'tinyssh-tests/opentest.c' || :
	mv -f 'tinyssh-tests/dropuidgidtest.c.orig' 'tinyssh-tests/dropuidgidtest.c' || :
	mv -f 'tinyssh-tests/subprocess_authtest.c.orig' 'tinyssh-tests/subprocess_authtest.c' || :
	mv -f 'conf-cc.orig' 'conf-cc' || :
	mv -f 'conf-ar.orig' 'conf-ar' || :

%:
	dh $@

=== debian/tests/control ===
--- 
+++ 
@@ -22,3 +22,9 @@
 
 Tests: 08badauth
 Depends: openssh-client, tinysshd, ucspi-tcp
+
+Tests: 09termexec
+Depends: openssh-client, tinysshd, ucspi-tcp
+
+Tests: 10rekey
+Depends: openssh-client, tinysshd, ucspi-tcp

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/archive\/.+\/(\d\S+)\.tar\.gz/releases\/download\/$1\/$1\.tar\.gz\.asc/ \
  https://github.com/janmojzis/tinyssh/tags .*/@ANY_VERSION@@ARCHIVE_EXT@

## tinyssh 20241111

=== Makefile ===
CC?=cc
CFLAGS+=-W -Wall -Os -fPIC -fwrapv -Werror=deprecated-declarations
LDFLAGS?=
CPPFLAGS?=

DESTDIR?=
PREFIX?=/usr/local

BINARIES=tinysshd _tinysshd-printkex _tinysshd-speed _tinysshd-test-hello1 \
 _tinysshd-test-hello2 _tinysshd-test-kex1 _tinysshd-test-kex2 \
 _tinysshd-unauthenticated

LINKS=tinysshd-makekey tinysshd-printkey tinysshnoneauthd

OBJECTS=blocking.o buf.o byte.o channel.o channel_drop.o channel_fork.o \
 channel_forkpty.o channel_subsystem.o cleanup.o coe.o connectioninfo.o \
 crypto_hash_sha256.o crypto_hash_sha512_lib25519.o crypto_hash_sha512_tinyssh.o \
 crypto_kem_sntrup761_libntruprime.o crypto_kem_sntrup761_tinyssh.o \
 crypto_kem_sntrup761x25519.o crypto_onetimeauth_poly1305.o \
 crypto_scalarmult_curve25519_lib25519.o crypto_scalarmult_curve25519_tinyssh.o \
 crypto_sign_ed25519_lib25519.o crypto_sign_ed25519_tinyssh.o \
 crypto_sort_uint32.o crypto_stream_chacha20.o crypto_verify_16.o \
 crypto_verify_32.o die.o dropuidgid.o e.o env.o fe25519.o fe.o ge25519.o \
 getln.o global.o iptostr.o load.o log.o loginshell.o logsys.o main_tinysshd.o \
 main_tinysshd_makekey.o main_tinysshd_printkey.o newenv.o numtostr.o open.o \
 packet_auth.o packet.o packet_channel_open.o packet_channel_recv.o \
 packet_channel_request.o packet_channel_send.o packet_get.o packet_hello.o \
 packet_kex.o packet_kexdh.o packetparser.o packet_put.o packet_recv.o \
 packet_send.o packet_unimplemented.o porttostr.o randombytes.o randommod.o \
 readall.o savesync.o sc25519.o ssh.o sshcrypto.o sshcrypto_cipher.o \
 sshcrypto_cipher_chachapoly.o sshcrypto_kex.o sshcrypto_kex_curve25519.o \
 sshcrypto_kex_sntrup761x25519.o sshcrypto_key.o sshcrypto_key_ed25519.o str.o \
 stringparser.o subprocess_auth.o subprocess_sign.o trymlock.o uint32_pack_big.o \
 uint32_pack.o uint32_unpack_big.o uint32_unpack.o verify.o writeall.o

BINOBJ=tinysshd.o _tinysshd-printkex.o _tinysshd-speed.o \
 _tinysshd-test-hello1.o _tinysshd-test-hello2.o _tinysshd-test-kex1.o \
 _tinysshd-test-kex2.o _tinysshd-unauthenticated.o

AUTOHEADERS=hasasmvolatilememory.h haslib25519.h haslibntruprime.h \
 haslibrandombytes.h haslibutilh.h haslimits.h haslogintty.h hasmlock.h \
 hasopenpty.h hasutilh.h hasutmpaddrv6.h hasutmp.h hasutmphost.h \
 hasutmploginlogout.h hasutmplogwtmp.h hasutmpname.h hasutmppid.h hasutmptime.h \
 hasutmptv.h hasutmptype.h hasutmpuser.h hasutmpxaddrv6.h hasutmpx.h \
 hasutmpxsyslen.h hasutmpxupdwtmpx.h

all: $(AUTOHEADERS) $(BINARIES) $(LINKS)

blocking.o: blocking.c blocking.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c blocking.c

buf.o: buf.c byte.h str.h purge.h cleanup.h randombytes.h \
 haslibrandombytes.h uint32_pack_big.h crypto_uint32.h bug.h global.h e.h \
 log.h buf.h crypto_uint8.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c buf.c

byte.o: byte.c byte.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c byte.c

channel.o: channel.c byte.h bug.h global.h e.h log.h newenv.h purge.h \
 cleanup.h connectioninfo.h iptostr.h porttostr.h buf.h crypto_uint8.h \
 crypto_uint32.h str.h logsys.h loginshell.h trymlock.h limit.h \
 haslimits.h channel.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c channel.c

channel_drop.o: channel_drop.c dropuidgid.h newenv.h channel.h \
 crypto_uint32.h iptostr.h porttostr.h limit.h haslimits.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c channel_drop.c

channel_fork.o: channel_fork.c blocking.h open.h channel.h \
 crypto_uint32.h iptostr.h porttostr.h limit.h haslimits.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c channel_fork.c

channel_forkpty.o: channel_forkpty.c hasopenpty.h haslogintty.h e.h coe.h \
 blocking.h global.h channel.h crypto_uint32.h iptostr.h porttostr.h \
 limit.h haslimits.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c channel_forkpty.c

channel_subsystem.o: channel_subsystem.c str.h log.h e.h channel.h \
 crypto_uint32.h iptostr.h porttostr.h limit.h haslimits.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c channel_subsystem.c

cleanup.o: cleanup.c cleanup.h hasasmvolatilememory.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c cleanup.c

coe.o: coe.c coe.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c coe.c

connectioninfo.o: connectioninfo.c e.h byte.h iptostr.h porttostr.h env.h \
 str.h connectioninfo.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c connectioninfo.c

crypto_hash_sha256.o: crypto_hash_sha256.c crypto_uint32.h \
 crypto_hash_sha256.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_hash_sha256.c

crypto_hash_sha512_lib25519.o: crypto_hash_sha512_lib25519.c \
 haslib25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_hash_sha512_lib25519.c

crypto_hash_sha512_tinyssh.o: crypto_hash_sha512_tinyssh.c haslib25519.h \
 crypto_hash_sha512.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_hash_sha512_tinyssh.c

crypto_kem_sntrup761_libntruprime.o: crypto_kem_sntrup761_libntruprime.c \
 haslibntruprime.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_kem_sntrup761_libntruprime.c

crypto_kem_sntrup761_tinyssh.o: crypto_kem_sntrup761_tinyssh.c \
 haslibntruprime.h crypto_uint64.h crypto_uint32.h crypto_uint16.h \
 crypto_int32.h crypto_int16.h crypto_int8.h randombytes.h \
 haslibrandombytes.h crypto_verify_32.h crypto_sort_uint32.h \
 crypto_hash_sha512.h haslib25519.h crypto_kem_sntrup761.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_kem_sntrup761_tinyssh.c

crypto_kem_sntrup761x25519.o: crypto_kem_sntrup761x25519.c randombytes.h \
 haslibrandombytes.h cleanup.h crypto_hash_sha512.h haslib25519.h \
 crypto_scalarmult_curve25519.h crypto_kem_sntrup761.h haslibntruprime.h \
 crypto_kem_sntrup761x25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_kem_sntrup761x25519.c

crypto_onetimeauth_poly1305.o: crypto_onetimeauth_poly1305.c \
 crypto_onetimeauth_poly1305.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_onetimeauth_poly1305.c

crypto_scalarmult_curve25519_lib25519.o: \
 crypto_scalarmult_curve25519_lib25519.c haslib25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_scalarmult_curve25519_lib25519.c

crypto_scalarmult_curve25519_tinyssh.o: \
 crypto_scalarmult_curve25519_tinyssh.c haslib25519.h cleanup.h fe25519.h \
 fe.h crypto_uint32.h crypto_uint64.h crypto_scalarmult_curve25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_scalarmult_curve25519_tinyssh.c

crypto_sign_ed25519_lib25519.o: crypto_sign_ed25519_lib25519.c \
 haslib25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_sign_ed25519_lib25519.c

crypto_sign_ed25519_tinyssh.o: crypto_sign_ed25519_tinyssh.c \
 haslib25519.h randombytes.h haslibrandombytes.h cleanup.h \
 crypto_hash_sha512.h crypto_verify_32.h ge25519.h fe.h crypto_uint32.h \
 crypto_uint64.h sc25519.h crypto_sign_ed25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_sign_ed25519_tinyssh.c

crypto_sort_uint32.o: crypto_sort_uint32.c crypto_uint32.h \
 crypto_sort_uint32.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_sort_uint32.c

crypto_stream_chacha20.o: crypto_stream_chacha20.c \
 crypto_stream_chacha20.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_stream_chacha20.c

crypto_verify_16.o: crypto_verify_16.c verify.h crypto_verify_16.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_verify_16.c

crypto_verify_32.o: crypto_verify_32.c verify.h crypto_verify_32.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_verify_32.c

die.o: die.c global.h log.h die.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c die.c

dropuidgid.o: dropuidgid.c e.h dropuidgid.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c dropuidgid.c

e.o: e.c e.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c e.c

env.o: env.c str.h env.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c env.c

fe25519.o: fe25519.c uint32_pack.h crypto_uint32.h uint32_unpack.h \
 crypto_verify_32.h cleanup.h fe.h crypto_uint64.h fe25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c fe25519.c

fe.o: fe.c fe.h crypto_uint32.h crypto_uint64.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c fe.c

ge25519.o: ge25519.c fe25519.h fe.h crypto_uint32.h crypto_uint64.h \
 cleanup.h ge25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c ge25519.c

getln.o: getln.c e.h getln.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c getln.c

global.o: global.c newenv.h channel.h crypto_uint32.h iptostr.h \
 porttostr.h limit.h haslimits.h packet.h buf.h crypto_uint8.h \
 sshcrypto.h crypto.h crypto_hash_sha256.h crypto_hash_sha512.h \
 haslib25519.h crypto_int16.h crypto_int32.h crypto_int64.h crypto_int8.h \
 crypto_kem_sntrup761.h haslibntruprime.h crypto_kem_sntrup761x25519.h \
 crypto_onetimeauth_poly1305.h crypto_scalarmult_curve25519.h \
 crypto_sign_ed25519.h crypto_sort_uint32.h crypto_stream_chacha20.h \
 crypto_uint16.h crypto_uint64.h crypto_verify_16.h crypto_verify_32.h \
 randombytes.h haslibrandombytes.h purge.h cleanup.h trymlock.h global.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c global.c

iptostr.o: iptostr.c byte.h iptostr.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c iptostr.c

load.o: load.c readall.h open.h e.h load.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c load.c

log.o: log.c writeall.h randommod.h purge.h cleanup.h numtostr.h e.h \
 log.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c log.c

loginshell.o: loginshell.c e.h loginshell.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c loginshell.c

logsys.o: logsys.c hasutilh.h hasutmpx.h hasutmpxupdwtmpx.h \
 hasutmpxsyslen.h hasutmpxaddrv6.h hasutmp.h hasutmpname.h hasutmppid.h \
 hasutmptime.h hasutmptv.h hasutmptype.h hasutmphost.h hasutmpuser.h \
 hasutmplogwtmp.h hasutmploginlogout.h hasutmpaddrv6.h str.h byte.h \
 logsys.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c logsys.c

main_tinysshd.o: main_tinysshd.c blocking.h ssh.h purge.h cleanup.h \
 open.h load.h e.h byte.h buf.h crypto_uint8.h crypto_uint32.h packet.h \
 sshcrypto.h crypto.h crypto_hash_sha256.h crypto_hash_sha512.h \
 haslib25519.h crypto_int16.h crypto_int32.h crypto_int64.h crypto_int8.h \
 crypto_kem_sntrup761.h haslibntruprime.h crypto_kem_sntrup761x25519.h \
 crypto_onetimeauth_poly1305.h crypto_scalarmult_curve25519.h \
 crypto_sign_ed25519.h crypto_sort_uint32.h crypto_stream_chacha20.h \
 crypto_uint16.h crypto_uint64.h crypto_verify_16.h crypto_verify_32.h \
 randombytes.h haslibrandombytes.h limit.h haslimits.h channel.h \
 iptostr.h porttostr.h log.h subprocess.h global.h connectioninfo.h die.h \
 str.h main.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c main_tinysshd.c

main_tinysshd_makekey.o: main_tinysshd_makekey.c savesync.h log.h \
 sshcrypto.h buf.h crypto_uint8.h crypto_uint32.h crypto.h \
 crypto_hash_sha256.h crypto_hash_sha512.h haslib25519.h crypto_int16.h \
 crypto_int32.h crypto_int64.h crypto_int8.h crypto_kem_sntrup761.h \
 haslibntruprime.h crypto_kem_sntrup761x25519.h \
 crypto_onetimeauth_poly1305.h crypto_scalarmult_curve25519.h \
 crypto_sign_ed25519.h crypto_sort_uint32.h crypto_stream_chacha20.h \
 crypto_uint16.h crypto_uint64.h crypto_verify_16.h crypto_verify_32.h \
 randombytes.h haslibrandombytes.h global.h die.h main.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c main_tinysshd_makekey.c

main_tinysshd_printkey.o: main_tinysshd_printkey.c e.h load.h sshcrypto.h \
 buf.h crypto_uint8.h crypto_uint32.h crypto.h crypto_hash_sha256.h \
 crypto_hash_sha512.h haslib25519.h crypto_int16.h crypto_int32.h \
 crypto_int64.h crypto_int8.h crypto_kem_sntrup761.h haslibntruprime.h \
 crypto_kem_sntrup761x25519.h crypto_onetimeauth_poly1305.h \
 crypto_scalarmult_curve25519.h crypto_sign_ed25519.h \
 crypto_sort_uint32.h crypto_stream_chacha20.h crypto_uint16.h \
 crypto_uint64.h crypto_verify_16.h crypto_verify_32.h randombytes.h \
 haslibrandombytes.h global.h log.h writeall.h die.h main.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c main_tinysshd_printkey.c

newenv.o: newenv.c e.h byte.h str.h purge.h cleanup.h bug.h global.h \
 log.h env.h trymlock.h newenv.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c newenv.c

numtostr.o: numtostr.c numtostr.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c numtostr.c

open.o: open.c blocking.h open.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c open.c

packet_auth.o: packet_auth.c buf.h crypto_uint8.h crypto_uint32.h ssh.h \
 e.h str.h packetparser.h subprocess.h sshcrypto.h crypto.h \
 crypto_hash_sha256.h crypto_hash_sha512.h haslib25519.h crypto_int16.h \
 crypto_int32.h crypto_int64.h crypto_int8.h crypto_kem_sntrup761.h \
 haslibntruprime.h crypto_kem_sntrup761x25519.h \
 crypto_onetimeauth_poly1305.h crypto_scalarmult_curve25519.h \
 crypto_sign_ed25519.h crypto_sort_uint32.h crypto_stream_chacha20.h \

=== debian/changelog ===
tinyssh (20241111-1) unstable; urgency=medium

  * New upstream version 20241111
  * d/control: bump Standards-Version to 4.7.0, no changes
  * d/p/0001-packet_put.c-include-global.h.patch: remove, fixed in upstream
  * d/rules: remove targets override_dh_auto_{configure,build,clean}
  * d/tinysshd.install: fix path
  * d/tinysshd.manpages: fix path
  * d/control: add B-D lib25519-dev, libnruprime-dev, librandombytes-dev

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Tue, 12 Nov 2024 00:21:13 +0100

tinyssh (20240101-3) unstable; urgency=medium

  * d/p/0001-packet_put.c-include-global.h.patch, fix FTBFS (Closes: #1066418)

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Wed, 13 Mar 2024 20:07:05 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,24 @@
 Source: tinyssh
 Section: net
 Priority: optional
-Build-Depends: debhelper-compat (= 13)
+Build-Depends:
+ debhelper-compat (= 13),
+ lib25519-dev,
+ libntruprime-dev,
+ librandombytes-dev
 Maintainer: Jan Mojžíš <jan.mojzis@gmail.com>
 Homepage: https://mojzis.com/software/tinyssh/
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/debian/tinyssh.git
 Vcs-Browser: https://salsa.debian.org/debian/tinyssh
 Rules-Requires-Root: no
 
 Package: tinysshd
-Depends: ${misc:Depends}, ${shlibs:Depends}
-Provides: ssh-server
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends}
+Provides:
+ ssh-server
 Architecture: any
 Description: Tiny SSH server - daemon
  TinySSH is a minimalistic SSH server which implements only a subset of

=== debian/tests/control ===
Tests: 01makekeyprintkey
Depends:
 tinysshd

Tests: 02handshake
Depends:
 python3,
 systemd,
 systemd-sysv,
 tinysshd,
 ucspi-tcp
Restrictions: allow-stderr, needs-root, isolation-container

Tests: 03exitcodes
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp

Tests: 04sftp
Depends:
 openssh-client,
 openssh-sftp-server,
 tinysshd,
 ucspi-tcp

Tests: 05authorizedkeys
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp

Tests: 06transfer
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp

Tests: 07kex
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp

Tests: 08badauth
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp

Tests: 09termexec
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp

Tests: 10rekey
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp

## tinyssh 20241201

=== Makefile ===
CC?=cc
CFLAGS+=-W -Wall -Os -fPIC -fwrapv -Werror=deprecated-declarations -Icryptoint
LDFLAGS?=
CPPFLAGS?=

DESTDIR?=
PREFIX?=/usr/local

INSTALL?=install

LINKS=tinysshd-makekey tinysshd-printkey tinysshnoneauthd

BINARIES=tinysshd _tinysshd-printkex _tinysshd-speed _tinysshd-test-hello1 \
 _tinysshd-test-hello2 _tinysshd-test-kex1 _tinysshd-test-kex2 \
 _tinysshd-unauthenticated

TESTCRYPTOBINARIES=test-crypto

OBJLIB=blocking.o buf.o byte.o channel.o channel_drop.o channel_fork.o \
 channel_forkpty.o channel_subsystem.o cleanup.o coe.o connectioninfo.o \
 crypto_dh_x25519.o crypto_hash_sha256.o crypto_hash_sha512_lib25519.o \
 crypto_hash_sha512_tinyssh.o crypto_kem_sntrup761_libntruprime.o \
 crypto_kem_sntrup761_tinyssh.o crypto_kem_sntrup761x25519.o \
 crypto_onetimeauth_poly1305.o crypto_scalarmult_curve25519.o \
 crypto_sign_ed25519_lib25519.o crypto_sign_ed25519_tinyssh.o \
 crypto_sort_uint32.o crypto_stream_chacha20.o crypto_verify_16.o \
 crypto_verify_32.o die.o dropuidgid.o e.o env.o fe25519.o fe.o ge25519.o \
 getln.o global.o int16_optblocker.o int32_optblocker.o int64_optblocker.o \
 int8_optblocker.o iptostr.o load.o log.o loginshell.o logsys.o main_tinysshd.o \
 main_tinysshd_makekey.o main_tinysshd_printkey.o newenv.o numtostr.o open.o \
 packet_auth.o packet.o packet_channel_open.o packet_channel_recv.o \
 packet_channel_request.o packet_channel_send.o packet_get.o packet_hello.o \
 packet_kex.o packet_kexdh.o packetparser.o packet_put.o packet_recv.o \
 packet_send.o packet_unimplemented.o porttostr.o randommod.o readall.o \
 savesync.o sc25519.o ssh.o sshcrypto.o sshcrypto_cipher.o \
 sshcrypto_cipher_chachapoly.o sshcrypto_kex.o sshcrypto_kex_curve25519.o \
 sshcrypto_kex_sntrup761x25519.o sshcrypto_key.o sshcrypto_key_ed25519.o str.o \
 stringparser.o subprocess_auth.o subprocess_sign.o trymlock.o \
 uint16_optblocker.o uint32_optblocker.o uint64_optblocker.o uint8_optblocker.o \
 writeall.o

OBJALL=blocking.o buf.o byte.o channel.o channel_drop.o channel_fork.o \
 channel_forkpty.o channel_subsystem.o cleanup.o coe.o connectioninfo.o \
 crypto_dh_x25519.o crypto_hash_sha256.o crypto_hash_sha512_lib25519.o \
 crypto_hash_sha512_tinyssh.o crypto_kem_sntrup761_libntruprime.o \
 crypto_kem_sntrup761_tinyssh.o crypto_kem_sntrup761x25519.o \
 crypto_onetimeauth_poly1305.o crypto_scalarmult_curve25519.o \
 crypto_sign_ed25519_lib25519.o crypto_sign_ed25519_tinyssh.o \
 crypto_sort_uint32.o crypto_stream_chacha20.o crypto_verify_16.o \
 crypto_verify_32.o die.o dropuidgid.o e.o env.o fe25519.o fe.o ge25519.o \
 getln.o global.o int16_optblocker.o int32_optblocker.o int64_optblocker.o \
 int8_optblocker.o iptostr.o load.o log.o loginshell.o logsys.o main_tinysshd.o \
 main_tinysshd_makekey.o main_tinysshd_printkey.o newenv.o numtostr.o open.o \
 packet_auth.o packet.o packet_channel_open.o packet_channel_recv.o \
 packet_channel_request.o packet_channel_send.o packet_get.o packet_hello.o \
 packet_kex.o packet_kexdh.o packetparser.o packet_put.o packet_recv.o \
 packet_send.o packet_unimplemented.o porttostr.o randombytes.o randommod.o \
 readall.o savesync.o sc25519.o ssh.o sshcrypto.o sshcrypto_cipher.o \
 sshcrypto_cipher_chachapoly.o sshcrypto_kex.o sshcrypto_kex_curve25519.o \
 sshcrypto_kex_sntrup761x25519.o sshcrypto_key.o sshcrypto_key_ed25519.o str.o \
 stringparser.o subprocess_auth.o subprocess_sign.o test-crypto.o tinysshd.o \
 _tinysshd-printkex.o _tinysshd-speed.o _tinysshd-test-hello1.o \
 _tinysshd-test-hello2.o _tinysshd-test-kex1.o _tinysshd-test-kex2.o \
 _tinysshd-unauthenticated.o trymlock.o uint16_optblocker.o uint32_optblocker.o \
 uint64_optblocker.o uint8_optblocker.o writeall.o

AUTOHEADERS=haslib25519.h haslibntruprime.h haslibrandombytes.h haslibutilh.h \
 haslimits.h haslogintty.h hasmlock.h hasopenpty.h hasutilh.h hasutmpaddrv6.h \
 hasutmp.h hasutmphost.h hasutmploginlogout.h hasutmplogwtmp.h hasutmpname.h \
 hasutmppid.h hasutmptime.h hasutmptv.h hasutmptype.h hasutmpuser.h \
 hasutmpxaddrv6.h hasutmpx.h hasutmpxsyslen.h hasutmpxupdwtmpx.h hasvalgrind.h

TESTOUT=test-crypto-dh.out test-crypto-hash.out test-crypto-kem.out \
 test-crypto-sign.out test-crypto-sort.out test-crypto-verify.out \
 test-tinysshd-makekey.out test-tinysshd-printkey.out test-tinysshd.out \
 test-tinysshnoneauthd.out

all: $(AUTOHEADERS) $(BINARIES) $(LINKS)

blocking.o: blocking.c blocking.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c blocking.c

buf.o: buf.c byte.h str.h purge.h cleanup.h randombytes.h \
 haslibrandombytes.h cryptoint/crypto_uint32.h bug.h global.h e.h log.h \
 buf.h cryptoint/crypto_uint8.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c buf.c

byte.o: byte.c byte.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c byte.c

channel.o: channel.c byte.h bug.h global.h e.h log.h newenv.h purge.h \
 cleanup.h connectioninfo.h iptostr.h porttostr.h buf.h \
 cryptoint/crypto_uint8.h cryptoint/crypto_uint32.h str.h logsys.h \
 loginshell.h trymlock.h limit.h haslimits.h channel.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c channel.c

channel_drop.o: channel_drop.c dropuidgid.h newenv.h channel.h \
 cryptoint/crypto_uint32.h iptostr.h porttostr.h limit.h haslimits.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c channel_drop.c

channel_fork.o: channel_fork.c blocking.h open.h channel.h \
 cryptoint/crypto_uint32.h iptostr.h porttostr.h limit.h haslimits.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c channel_fork.c

channel_forkpty.o: channel_forkpty.c hasopenpty.h haslogintty.h e.h coe.h \
 blocking.h global.h channel.h cryptoint/crypto_uint32.h iptostr.h \
 porttostr.h limit.h haslimits.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c channel_forkpty.c

channel_subsystem.o: channel_subsystem.c str.h log.h e.h channel.h \
 cryptoint/crypto_uint32.h iptostr.h porttostr.h limit.h haslimits.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c channel_subsystem.c

cleanup.o: cleanup.c cleanup.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c cleanup.c

coe.o: coe.c coe.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c coe.c

connectioninfo.o: connectioninfo.c e.h byte.h iptostr.h porttostr.h env.h \
 str.h connectioninfo.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c connectioninfo.c

crypto_dh_x25519.o: crypto_dh_x25519.c crypto_dh_x25519.h haslib25519.h \
 randombytes.h haslibrandombytes.h crypto_scalarmult_curve25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_dh_x25519.c

crypto_hash_sha256.o: crypto_hash_sha256.c cryptoint/crypto_uint32.h \
 crypto_hash_sha256.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_hash_sha256.c

crypto_hash_sha512_lib25519.o: crypto_hash_sha512_lib25519.c \
 haslib25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_hash_sha512_lib25519.c

crypto_hash_sha512_tinyssh.o: crypto_hash_sha512_tinyssh.c \
 crypto_hash_sha512.h haslib25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_hash_sha512_tinyssh.c

crypto_kem_sntrup761_libntruprime.o: crypto_kem_sntrup761_libntruprime.c \
 haslibntruprime.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_kem_sntrup761_libntruprime.c

crypto_kem_sntrup761_tinyssh.o: crypto_kem_sntrup761_tinyssh.c \
 haslibntruprime.h cryptoint/crypto_uint64.h cryptoint/crypto_uint32.h \
 cryptoint/crypto_uint16.h cryptoint/crypto_int32.h \
 cryptoint/crypto_int16.h cryptoint/crypto_int8.h randombytes.h \
 haslibrandombytes.h crypto_verify_32.h crypto_sort_uint32.h \
 crypto_hash_sha512.h haslib25519.h crypto_declassify.h hasvalgrind.h \
 crypto_kem_sntrup761.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_kem_sntrup761_tinyssh.c

crypto_kem_sntrup761x25519.o: crypto_kem_sntrup761x25519.c randombytes.h \
 haslibrandombytes.h cleanup.h crypto_hash_sha512.h haslib25519.h \
 crypto_scalarmult_curve25519.h crypto_kem_sntrup761.h haslibntruprime.h \
 crypto_kem_sntrup761x25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_kem_sntrup761x25519.c

crypto_onetimeauth_poly1305.o: crypto_onetimeauth_poly1305.c \
 crypto_onetimeauth_poly1305.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_onetimeauth_poly1305.c

crypto_scalarmult_curve25519.o: crypto_scalarmult_curve25519.c cleanup.h \
 fe25519.h fe.h cryptoint/crypto_uint32.h cryptoint/crypto_uint64.h \
 crypto_scalarmult_curve25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_scalarmult_curve25519.c

crypto_sign_ed25519_lib25519.o: crypto_sign_ed25519_lib25519.c \
 haslib25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_sign_ed25519_lib25519.c

crypto_sign_ed25519_tinyssh.o: crypto_sign_ed25519_tinyssh.c \
 haslib25519.h randombytes.h haslibrandombytes.h cleanup.h \
 crypto_hash_sha512.h crypto_verify_32.h ge25519.h fe.h \
 cryptoint/crypto_uint32.h cryptoint/crypto_uint64.h sc25519.h \
 crypto_sign_ed25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_sign_ed25519_tinyssh.c

crypto_sort_uint32.o: crypto_sort_uint32.c cryptoint/crypto_uint32.h \
 crypto_sort_uint32.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_sort_uint32.c

crypto_stream_chacha20.o: crypto_stream_chacha20.c \
 crypto_stream_chacha20.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_stream_chacha20.c

crypto_verify_16.o: crypto_verify_16.c cryptoint/crypto_int16.h \
 crypto_verify_16.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_verify_16.c

crypto_verify_32.o: crypto_verify_32.c cryptoint/crypto_int16.h \
 crypto_verify_32.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_verify_32.c

die.o: die.c global.h log.h die.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c die.c

dropuidgid.o: dropuidgid.c e.h dropuidgid.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c dropuidgid.c

e.o: e.c e.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c e.c

env.o: env.c str.h env.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c env.c

fe25519.o: fe25519.c crypto_verify_32.h cleanup.h fe.h \
 cryptoint/crypto_uint32.h cryptoint/crypto_uint64.h fe25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c fe25519.c

fe.o: fe.c fe.h cryptoint/crypto_uint32.h cryptoint/crypto_uint64.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c fe.c

ge25519.o: ge25519.c fe25519.h fe.h cryptoint/crypto_uint32.h \
 cryptoint/crypto_uint64.h cleanup.h ge25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c ge25519.c

getln.o: getln.c e.h getln.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c getln.c

global.o: global.c newenv.h channel.h cryptoint/crypto_uint32.h iptostr.h \
 porttostr.h limit.h haslimits.h packet.h buf.h cryptoint/crypto_uint8.h \
 sshcrypto.h crypto.h cryptoint/crypto_int16.h cryptoint/crypto_int32.h \
 cryptoint/crypto_int64.h cryptoint/crypto_int8.h \
 cryptoint/crypto_uint16.h cryptoint/crypto_uint64.h crypto_verify_16.h \
 crypto_verify_32.h haslibrandombytes.h randombytes.h \
 crypto_hash_sha256.h crypto_hash_sha512.h haslib25519.h \
 crypto_kem_sntrup761.h haslibntruprime.h crypto_kem_sntrup761x25519.h \
 crypto_onetimeauth_poly1305.h crypto_scalarmult_curve25519.h \
 crypto_dh_x25519.h crypto_sign_ed25519.h crypto_sort_uint32.h \
 crypto_stream_chacha20.h purge.h cleanup.h trymlock.h global.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c global.c

int16_optblocker.o: int16_optblocker.c cryptoint/crypto_int16.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c int16_optblocker.c

int32_optblocker.o: int32_optblocker.c cryptoint/crypto_int32.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c int32_optblocker.c

int64_optblocker.o: int64_optblocker.c cryptoint/crypto_int64.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c int64_optblocker.c

int8_optblocker.o: int8_optblocker.c cryptoint/crypto_int8.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c int8_optblocker.c

iptostr.o: iptostr.c byte.h iptostr.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c iptostr.c

load.o: load.c readall.h open.h e.h load.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c load.c

log.o: log.c writeall.h randommod.h purge.h cleanup.h numtostr.h e.h \
 log.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c log.c

loginshell.o: loginshell.c e.h loginshell.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c loginshell.c

logsys.o: logsys.c hasutilh.h hasutmpx.h hasutmpxupdwtmpx.h \
 hasutmpxsyslen.h hasutmpxaddrv6.h hasutmp.h hasutmpname.h hasutmppid.h \
 hasutmptime.h hasutmptv.h hasutmptype.h hasutmphost.h hasutmpuser.h \
 hasutmplogwtmp.h hasutmploginlogout.h hasutmpaddrv6.h str.h byte.h \
 logsys.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c logsys.c

main_tinysshd.o: main_tinysshd.c blocking.h ssh.h purge.h cleanup.h \
 open.h load.h e.h byte.h buf.h cryptoint/crypto_uint8.h \
 cryptoint/crypto_uint32.h packet.h sshcrypto.h crypto.h \

=== debian/changelog ===
tinyssh (20241201-1) unstable; urgency=medium

  * New upstream version 20241201
  * d/t: use 'ssh-keyscan -t ed25519' in tests, to minimize the number of
    warnings in the log
  * d/copyright: add copyright for cryptoint/*
  * d/gbp.conf: dist = DEP14, debian-branch = debian/latest
  * d/control: update homepage to https://github.com/janmojzis/tinyssh/
  * d/copyright: update homepage to https://github.com/janmojzis/tinyssh/
  * d/control: update maintainer to janmojzis@debian.org
  * d/t/valgrindtest.sh add

 -- Jan Mojžíš <janmojzis@debian.org>  Sun, 01 Dec 2024 16:18:32 +0100

## tinyssh 20250126

=== debian/changelog ===
tinyssh (20250126-1) unstable; urgency=medium

  * New upstream version 20250126
  * d/copyright: bump my copyright year
  * d/copyright: update my email to "janmojzis@debian.org"

 -- Jan Mojžíš <janmojzis@debian.org>  Sun, 26 Jan 2025 21:56:43 +0100
